summaryrefslogtreecommitdiffstats
path: root/Modules
diff options
context:
space:
mode:
Diffstat (limited to 'Modules')
-rwxr-xr-xModules/ar_beos73
-rwxr-xr-xModules/ld_so_beos79
2 files changed, 152 insertions, 0 deletions
diff --git a/Modules/ar_beos b/Modules/ar_beos
new file mode 100755
index 0000000..e7efa75
--- /dev/null
+++ b/Modules/ar_beos
@@ -0,0 +1,73 @@
+#!/bin/sh
+#
+# Truly fake ar, using a directory to store object files.
+#
+# Donn Cave, donn@oz.net
+
+usage='Usage: ar-fake cr libpython.dir obj.o ...
+ ar-fake d libpython.dir obj.o ...
+ ar-fake so libpython.dir libpython.so'
+
+case $# in
+0|1|2)
+ echo "$usage" >&2
+ exit 1
+ ;;
+esac
+
+command=$1
+library=$2
+shift 2
+
+case $command in
+cr)
+ if test -d $library
+ then :
+ else
+ mkdir $library
+ fi
+ if cp -p $* $library
+ then
+ # To force directory modify date, create or delete a file.
+ if test -e $library/.tch
+ then rm $library/.tch
+ else echo tch > $library/.tch
+ fi
+ exit 0
+ fi
+ ;;
+d)
+ if test -d $library
+ then
+ cd $library
+ rm -f $*
+ fi
+ ;;
+so)
+ case $BE_HOST_CPU in
+ ppc)
+ # In case your libpython.a refers to any exotic libraries,
+ # mwld needs to know that here. The following hack makes
+ # a couple of assumptions about Modules/Makefile. If it
+ # doesn't work, you may as well add the necessary libraries
+ # here explicitly instead.
+ extralibs=$(
+ (cd Modules; make -f Makefile -n link) |
+ sed -n 's/.*\.so \(.*\) -o python.*/\1/p'
+ )
+ mwld -xms -export pragma -nodup -o $1 $library/* $extralibs
+ ;;
+ x86)
+ ld -shared -soname $(basename $1) -o $1 $library/*
+ ;;
+ esac
+ status=$?
+ cd $(dirname $1)
+ ln -sf $PWD lib
+ exit $status
+ ;;
+*)
+ echo "$usage" >&2
+ exit 1
+ ;;
+esac
diff --git a/Modules/ld_so_beos b/Modules/ld_so_beos
new file mode 100755
index 0000000..ac20cd2
--- /dev/null
+++ b/Modules/ld_so_beos
@@ -0,0 +1,79 @@
+#! /bin/sh
+#
+# linkmodule for Python
+# Chris Herborth (chrish@qnx.com)
+#
+# This is covered by the same copyright/licensing terms as the rest of
+# Python.
+#
+# Shell script to build shared library versions of the modules; since
+# the change to the *ahem* "proper" import/export mechanism, this script
+# is much simpler. It handles PowerPC and x86, too.
+#
+# This is called by the Modules/Makefile as $(LDSHARED):
+#
+# $(LDSHARED) foomodule.o -o foomodule$(SO)
+#
+# Could also be called as:
+#
+# $(LDSHARED) readline.o -L/boot/home/config/lib -lreadline -ltermcap \
+# -o readline$(SO)
+#
+# so we need to preserve the arguments, sort of.
+
+# Make sure we got reasonable arguments.
+TARGET=""
+ARGS=""
+VERSION=2.0
+
+while [ "$#" != "0" ]; do
+ case "$1" in
+ -o) TARGET="$2"; shift; shift;;
+ *) ARGS="$ARGS $1"; shift;;
+ esac
+done
+
+if [ "$TARGET" = "" ] ; then
+ echo "Usage:"
+ echo
+ echo " $0 [args] -o foomodule.so [args] foomodule.o [args]"
+ echo
+ echo "Where:"
+ echo
+ echo " [args] normal compiler arguments"
+ exit 1
+fi
+
+# The shared libraries and glue objects we need to link against; these
+# libs are overkill for most of the standard modules, but it makes life
+# in this shell script easier.
+LIBS="-L.. -lpython$VERSION -lbe -lnet -lroot"
+
+case $BE_HOST_CPU in
+ ppc)
+ # Boy, do we need a lot of crap...
+ GLUE_LOC=/boot/develop/lib/ppc
+ GLUE="${GLUE_LOC}/glue-noinit.a ${GLUE_LOC}/init_term_dyn.o"
+ case $(uname -r) in
+ 4.0*) CC="mwcc -xms -export pragma -nodup" ;;
+ *) CC="mwcc -shared -export pragma -nodup" ;;
+ esac
+ ;;
+
+ x86)
+ # We don't need as much crap here...
+ GLUE=""
+ CC="gcc -nostart -Wl,-soname=${TARGET}"
+ ;;
+
+ *)
+ # What the?!?
+ echo "$0 doesn't support $BE_HOST_CPU systems..."
+ echo "You're on your own... I'd be surprised if this works."
+ GLUE=""
+ CC="cc"
+ ;;
+esac
+
+# Now link that shared lib...
+$CC -o $TARGET $ARGS $GLUE $LIBS